###############################################################
##### Detec??o de Eventos - Produto e Produ??o Industrial #####
###############################################################

################
##### Data #####
################

library(tibble)
library(EventDetectR)
library(anomalize)
source("https://raw.githubusercontent.com/cefet-rj-dal/harbinger/master/harbinger.R")

attach(df_output)
head(df_output)
str(df_output)

test_cli <- subset(df_output, select = c(Data, cli))
test_ibcbr <- subset(df_output, select = c(Data, ibcbr))
test_pi_sudeste <- subset(df_output, select = c(Data, pi_sudeste))
test_pi_norte <- subset(df_output, select = c(Data, pi_norte))
test_pi_sul <- subset(df_output, select = c(Data, pi_sul))
test_pi_centro_oeste <- subset(df_output, select = c(Data, pi_centro_oeste))
test_pi_nordeste <- subset(df_output, select = c(Data, pi_nordeste))
reference <- subset(df_output, select = c(Data, event))

#####################
##### Anomalize #####
#####################

##### 1. cli #####
#Detect
anomalize_cli <- evtdet.anomalize(test_cli, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Evaluate
evaluate(anomalize_cli, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     9      4       
# FALSE    56     180  

round(evaluate(anomalize_cli, reference, metric = "F1"), 2)          # 0.23
round(evaluate(anomalize_cli, reference, metric = "accuracy"), 2)    # 0.76
round(evaluate(anomalize_cli, reference, metric = "sensitivity"), 2) # 0.14
round(evaluate(anomalize_cli, reference, metric = "specificity"), 2) # 0.98
round(evaluate(anomalize_cli, reference, metric = "precision"), 2)   # 0.69
round(evaluate(anomalize_cli, reference, metric = "recall"), 2)      # 0.14

#Plot
print(evtplot(test_cli, anomalize_cli, reference))

##### 2. ibcbr #####
#Detect
anomalize_ibcbr <- evtdet.anomalize(test_ibcbr, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Evaluate
evaluate(anomalize_ibcbr, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     7      4    
# FALSE    58     180  

round(evaluate(anomalize_ibcbr, reference, metric = "F1"), 2)          # 0.18
round(evaluate(anomalize_ibcbr, reference, metric = "accuracy"), 2)    # 0.75
round(evaluate(anomalize_ibcbr, reference, metric = "sensitivity"), 2) # 0.11
round(evaluate(anomalize_ibcbr, reference, metric = "specificity"), 2) # 0.98
round(evaluate(anomalize_ibcbr, reference, metric = "precision"), 2)   # 0.64
round(evaluate(anomalize_ibcbr, reference, metric = "recall"), 2)      # 0.11

#Plot
print(evtplot(test_ibcbr, anomalize_ibcbr, reference))

##### 3. pi_sudeste #####
#Detect
anomalize_pi_sudeste <- evtdet.anomalize(test_pi_sudeste, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Evaluate
evaluate(anomalize_pi_sudeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     7      7    
# FALSE    58     177  

round(evaluate(anomalize_pi_sudeste, reference, metric = "F1"), 2)          # 0.18
round(evaluate(anomalize_pi_sudeste, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(anomalize_pi_sudeste, reference, metric = "sensitivity"), 2) # 0.11
round(evaluate(anomalize_pi_sudeste, reference, metric = "specificity"), 2) # 0.96
round(evaluate(anomalize_pi_sudeste, reference, metric = "precision"), 2)   # 0.50
round(evaluate(anomalize_pi_sudeste, reference, metric = "recall"), 2)      # 0.11

#Plot
print(evtplot(test_pi_sudeste, anomalize_pi_sudeste, reference))

##### 4. pi_norte #####
#Detect
anomalize_pi_norte <- evtdet.anomalize(test_pi_norte, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Evaluate
evaluate(anomalize_pi_norte, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     3      6    
# FALSE    62     178

round(evaluate(anomalize_pi_norte, reference, metric = "F1"), 2)          # 0.08
round(evaluate(anomalize_pi_norte, reference, metric = "accuracy"), 2)    # 0.73
round(evaluate(anomalize_pi_norte, reference, metric = "sensitivity"), 2) # 0.05
round(evaluate(anomalize_pi_norte, reference, metric = "specificity"), 2) # 0.97
round(evaluate(anomalize_pi_norte, reference, metric = "precision"), 2)   # 0.33
round(evaluate(anomalize_pi_norte, reference, metric = "recall"), 2)      # 0.05

#Plot
print(evtplot(test_pi_norte, anomalize_pi_norte, reference))

##### 5. pi_sul #####
#Detect
anomalize_pi_sul <- evtdet.anomalize(test_pi_sul, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Evaluate
evaluate(anomalize_pi_sul, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     5      1    
# FALSE    60     183  

round(evaluate(anomalize_pi_sul, reference, metric = "F1"), 2)          # 0.14
round(evaluate(anomalize_pi_sul, reference, metric = "accuracy"), 2)    # 0.76
round(evaluate(anomalize_pi_sul, reference, metric = "sensitivity"), 2) # 0.08
round(evaluate(anomalize_pi_sul, reference, metric = "specificity"), 2) # 0.99
round(evaluate(anomalize_pi_sul, reference, metric = "precision"), 2)   # 0.83
round(evaluate(anomalize_pi_sul, reference, metric = "recall"), 2)      # 0.08

#Plot
print(evtplot(test_pi_sul, anomalize_pi_sul, reference))

##### 6. pi_centro_oeste #####
#Detect
anomalize_pi_centro_oeste <- evtdet.anomalize(test_pi_centro_oeste, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1 

#Evaluate
evaluate(anomalize_pi_centro_oeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(anomalize_pi_centro_oeste, reference, metric = "F1"), 2)          # 
round(evaluate(anomalize_pi_centro_oeste, reference, metric = "accuracy"), 2)    # 
round(evaluate(anomalize_pi_centro_oeste, reference, metric = "sensitivity"), 2) # 
round(evaluate(anomalize_pi_centro_oeste, reference, metric = "specificity"), 2) # 
round(evaluate(anomalize_pi_centro_oeste, reference, metric = "precision"), 2)   # 
round(evaluate(anomalize_pi_centro_oeste, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_pi_centro_oeste, anomalize_pi_centro_oeste, reference))

##### 7. pi_nordeste #####
#Detect
anomalize_pi_nordeste <- evtdet.anomalize(test_pi_nordeste, alpha = 0.1, max_anoms = 0.2, na.action = na.omit)

#Evaluate
evaluate(anomalize_pi_nordeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     5      7    
# FALSE    60     177  

round(evaluate(anomalize_pi_nordeste, reference, metric = "F1"), 2)          # 0.13
round(evaluate(anomalize_pi_nordeste, reference, metric = "accuracy"), 2)    # 0.73
round(evaluate(anomalize_pi_nordeste, reference, metric = "sensitivity"), 2) # 0.08
round(evaluate(anomalize_pi_nordeste, reference, metric = "specificity"), 2) # 0.96
round(evaluate(anomalize_pi_nordeste, reference, metric = "precision"), 2)   # 0.42
round(evaluate(anomalize_pi_nordeste, reference, metric = "recall"), 2)      # 0.08

#Plot
print(evtplot(test_pi_nordeste, anomalize_pi_nordeste, reference))

###########################################
##### Adaptive Normalization Outliers #####
###########################################

##### 1. cli #####
#Detect
an_cli <- evtdet.an_outliers(test_cli, w = 30, alpha = 1.5, na.action = na.omit)

evaluate(an_cli, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     5      0    
# FALSE    60     184  

round(evaluate(an_cli, reference, metric = "F1"), 2)          # 0.14
round(evaluate(an_cli, reference, metric = "accuracy"), 2)    # 0.76
round(evaluate(an_cli, reference, metric = "sensitivity"), 2) # 0.08
round(evaluate(an_cli, reference, metric = "specificity"), 2) # 1.00
round(evaluate(an_cli, reference, metric = "precision"), 2)   # 1.00
round(evaluate(an_cli, reference, metric = "recall"), 2)      # 0.08

#Plot
print(evtplot(test_cli, an_cli, reference))

##### 2. ibcbr #####
#Detect
an_ibcbr <- evtdet.an_outliers(test_ibcbr, w = 30, alpha = 1.5, na.action = na.omit)

#Evaluate
evaluate(an_ibcbr, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     6      0 
# FALSE    59     184

round(evaluate(an_ibcbr, reference, metric = "F1"), 2)          # 0.17
round(evaluate(an_ibcbr, reference, metric = "accuracy"), 2)    # 0.76
round(evaluate(an_ibcbr, reference, metric = "sensitivity"), 2) # 0.09
round(evaluate(an_ibcbr, reference, metric = "specificity"), 2) # 1.00
round(evaluate(an_ibcbr, reference, metric = "precision"), 2)   # 1.00
round(evaluate(an_ibcbr, reference, metric = "recall"), 2)      # 0.09

#Plot
print(evtplot(test_ibcbr, an_ibcbr, reference))

##### 3. pi_sudeste #####
#Detect
an_pi_sudeste <- evtdet.an_outliers(test_pi_sudeste, w = 30, alpha = 1.5, na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1 

#Evaluate
evaluate(an_pi_sudeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(an_pi_sudeste, reference, metric = "F1"), 2)          # 
round(evaluate(an_pi_sudeste, reference, metric = "accuracy"), 2)    # 
round(evaluate(an_pi_sudeste, reference, metric = "sensitivity"), 2) # 
round(evaluate(an_pi_sudeste, reference, metric = "specificity"), 2) # 
round(evaluate(an_pi_sudeste, reference, metric = "precision"), 2)   # 
round(evaluate(an_pi_sudeste, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_pi_sudeste, an_pi_sudeste, reference))

##### 4. pi_norte #####
#Detect
an_pi_norte <- evtdet.an_outliers(test_pi_norte, w = 30, alpha = 1.5, na.action = na.omit)

#Evaluate
evaluate(an_pi_norte, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     2      2 
# FALSE    63     182  

round(evaluate(an_pi_norte, reference, metric = "F1"), 2)          # 0.06
round(evaluate(an_pi_norte, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(an_pi_norte, reference, metric = "sensitivity"), 2) # 0.03
round(evaluate(an_pi_norte, reference, metric = "specificity"), 2) # 0.99
round(evaluate(an_pi_norte, reference, metric = "precision"), 2)   # 0.50
round(evaluate(an_pi_norte, reference, metric = "recall"), 2)      # 0.03

#Plot
print(evtplot(test_pi_norte, an_pi_norte, reference))

##### 5. pi_sul #####
#Detect
an_pi_sul <- evtdet.an_outliers(test_pi_sul, w = 30, alpha = 1.5, na.action = na.omit)

#Evaluate
evaluate(an_pi_sul, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     1      1    
# FALSE    64     183  

round(evaluate(an_pi_sul, reference, metric = "F1"), 2)          # 0.03
round(evaluate(an_pi_sul, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(an_pi_sul, reference, metric = "sensitivity"), 2) # 0.02
round(evaluate(an_pi_sul, reference, metric = "specificity"), 2) # 0.99
round(evaluate(an_pi_sul, reference, metric = "precision"), 2)   # 0.50
round(evaluate(an_pi_sul, reference, metric = "recall"), 2)      # 0.02

#Plot
print(evtplot(test_pi_sul, an_pi_sul, reference))

##### 6. pi_centro_oeste #####
#Detect
an_pi_centro_oeste <- evtdet.an_outliers(test_pi_centro_oeste, w = 30, alpha = 1.5, na.action = na.omit)

#Evaluate
evaluate(an_pi_centro_oeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     1      2    
# FALSE    64     182   

round(evaluate(an_pi_centro_oeste, reference, metric = "F1"), 2)          # 0.03
round(evaluate(an_pi_centro_oeste, reference, metric = "accuracy"), 2)    # 0.73
round(evaluate(an_pi_centro_oeste, reference, metric = "sensitivity"), 2) # 0.02
round(evaluate(an_pi_centro_oeste, reference, metric = "specificity"), 2) # 0.99
round(evaluate(an_pi_centro_oeste, reference, metric = "precision"), 2)   # 0.33
round(evaluate(an_pi_centro_oeste, reference, metric = "recall"), 2)      # 0.02

#Plot
print(evtplot(test_pi_centro_oeste, an_pi_centro_oeste, reference))

##### 7. pi_nordeste #####
#Detect
an_pi_nordeste <- evtdet.an_outliers(test_pi_nordeste, w = 30, alpha = 1.5, na.action = na.omit)

#Evaluate
evaluate(an_pi_nordeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     3      2     
# FALSE    62     182  

round(evaluate(an_pi_nordeste, reference, metric = "F1"), 2)          # 0.09
round(evaluate(an_pi_nordeste, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(an_pi_nordeste, reference, metric = "sensitivity"), 2) # 0.05
round(evaluate(an_pi_nordeste, reference, metric = "specificity"), 2) # 0.99
round(evaluate(an_pi_nordeste, reference, metric = "precision"), 2)   # 0.60
round(evaluate(an_pi_nordeste, reference, metric = "recall"), 2)      # 0.05

#Plot
print(evtplot(test_pi_nordeste, an_pi_nordeste, reference))

#######################
##### EventDetect #####
#######################

##### 1. cli #####
#Detect
eventdetect_cli <- evtdet.eventdetect(na.omit(test_cli), w = 30)

#Evaluate
evaluate(eventdetect_cli, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     34     136  
# FALSE    31     48 

round(evaluate(eventdetect_cli, reference, metric = "F1"), 2)          # 0.29
round(evaluate(eventdetect_cli, reference, metric = "accuracy"), 2)    # 0.33
round(evaluate(eventdetect_cli, reference, metric = "sensitivity"), 2) # 0.52
round(evaluate(eventdetect_cli, reference, metric = "specificity"), 2) # 0.26
round(evaluate(eventdetect_cli, reference, metric = "precision"), 2)   # 0.20
round(evaluate(eventdetect_cli, reference, metric = "recall"), 2)      # 0.52

#Plot
print(evtplot(test_cli, eventdetect_cli, reference))

##### 2. ibcbr #####
#Detect
eventdetect_ibcbr <- evtdet.eventdetect(na.omit(test_ibcbr), w = 30)

#Evaluate
evaluate(eventdetect_ibcbr, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     35     75  
# FALSE    30     109   

round(evaluate(eventdetect_ibcbr, reference, metric = "F1"), 2)          # 0.40
round(evaluate(eventdetect_ibcbr, reference, metric = "accuracy"), 2)    # 0.58
round(evaluate(eventdetect_ibcbr, reference, metric = "sensitivity"), 2) # 0.54
round(evaluate(eventdetect_ibcbr, reference, metric = "specificity"), 2) # 0.59
round(evaluate(eventdetect_ibcbr, reference, metric = "precision"), 2)   # 0.32
round(evaluate(eventdetect_ibcbr, reference, metric = "recall"), 2)      # 0.54

#Plot
print(evtplot(test_ibcbr, eventdetect_ibcbr, reference))

##### 3. pi_sudeste #####
#Detect
eventdetect_pi_sudeste <- evtdet.eventdetect(na.omit(test_pi_sudeste), w = 30)

#Evaluate
evaluate(eventdetect_pi_sudeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     20     61 
# FALSE    45     123  

round(evaluate(eventdetect_pi_sudeste, reference, metric = "F1"), 2)          # 0.27
round(evaluate(eventdetect_pi_sudeste, reference, metric = "accuracy"), 2)    # 0.57
round(evaluate(eventdetect_pi_sudeste, reference, metric = "sensitivity"), 2) # 0.31
round(evaluate(eventdetect_pi_sudeste, reference, metric = "specificity"), 2) # 0.67
round(evaluate(eventdetect_pi_sudeste, reference, metric = "precision"), 2)   # 0.25
round(evaluate(eventdetect_pi_sudeste, reference, metric = "recall"), 2)      # 0.31

#Plot
print(evtplot(test_pi_sudeste, eventdetect_pi_sudeste, reference))

##### 4. pi_norte #####
#Detect
eventdetect_pi_norte <- evtdet.eventdetect(na.omit(test_pi_norte), w = 30)

#Evaluate
evaluate(eventdetect_pi_norte, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     48     79     
# FALSE    17     105  

round(evaluate(eventdetect_pi_norte, reference, metric = "F1"), 2)          # 0.50
round(evaluate(eventdetect_pi_norte, reference, metric = "accuracy"), 2)    # 0.61
round(evaluate(eventdetect_pi_norte, reference, metric = "sensitivity"), 2) # 0.74
round(evaluate(eventdetect_pi_norte, reference, metric = "specificity"), 2) # 0.57
round(evaluate(eventdetect_pi_norte, reference, metric = "precision"), 2)   # 0.38
round(evaluate(eventdetect_pi_norte, reference, metric = "recall"), 2)      # 0.74

#Plot
print(evtplot(test_pi_norte, eventdetect_pi_norte, reference))

##### 5. pi_sul #####
#Detect
eventdetect_pi_sul <- evtdet.eventdetect(na.omit(test_pi_sul), w = 30)

#Evaluate
evaluate(eventdetect_pi_sul, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     20     56  
# FALSE    45     128   

round(evaluate(eventdetect_pi_sul, reference, metric = "F1"), 2)          # 0.28
round(evaluate(eventdetect_pi_sul, reference, metric = "accuracy"), 2)    # 0.59
round(evaluate(eventdetect_pi_sul, reference, metric = "sensitivity"), 2) # 0.31
round(evaluate(eventdetect_pi_sul, reference, metric = "specificity"), 2) # 0.70
round(evaluate(eventdetect_pi_sul, reference, metric = "precision"), 2)   # 0.26
round(evaluate(eventdetect_pi_sul, reference, metric = "recall"), 2)      # 0.31

#Plot
print(evtplot(test_pi_sul, eventdetect_pi_sul, reference))

##### 6. pi_centro_oeste #####
#Detect
eventdetect_pi_centro_oeste <- evtdet.eventdetect(na.omit(test_pi_centro_oeste), w = 30)

#Evaluate
evaluate(eventdetect_pi_centro_oeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     38     77 
# FALSE    27     107  

round(evaluate(eventdetect_pi_centro_oeste, reference, metric = "F1"), 2)          # 0.42
round(evaluate(eventdetect_pi_centro_oeste, reference, metric = "accuracy"), 2)    # 0.58
round(evaluate(eventdetect_pi_centro_oeste, reference, metric = "sensitivity"), 2) # 0.58
round(evaluate(eventdetect_pi_centro_oeste, reference, metric = "specificity"), 2) # 0.58
round(evaluate(eventdetect_pi_centro_oeste, reference, metric = "precision"), 2)   # 0.33
round(evaluate(eventdetect_pi_centro_oeste, reference, metric = "recall"), 2)      # 0.58

#Plot
print(evtplot(test_pi_centro_oeste, eventdetect_pi_centro_oeste, reference))

##### 7. pi_nordeste #####
#Detect
eventdetect_pi_nordeste <- evtdet.eventdetect(na.omit(test_pi_nordeste), w = 30)

#Evaluate
evaluate(eventdetect_pi_nordeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     36     65 
# FALSE    29     119  

round(evaluate(eventdetect_pi_nordeste, reference, metric = "F1"), 2)          # 0.43
round(evaluate(eventdetect_pi_nordeste, reference, metric = "accuracy"), 2)    # 0.62
round(evaluate(eventdetect_pi_nordeste, reference, metric = "sensitivity"), 2) # 0.55
round(evaluate(eventdetect_pi_nordeste, reference, metric = "specificity"), 2) # 0.65
round(evaluate(eventdetect_pi_nordeste, reference, metric = "precision"), 2)   # 0.36
round(evaluate(eventdetect_pi_nordeste, reference, metric = "recall"), 2)      # 0.55

#Plot
print(evtplot(test_pi_nordeste, eventdetect_pi_nordeste, reference))

#######################################
##### Auxiliary Model definitions #####
#######################################

ARIMA <- function(data) forecast::auto.arima(data)
AR <- function(data,p) forecast::Arima(data, order = c(p, 0, 0), seasonal = c(0, 0, 0))
garch <- function(data,spec,...) rugarch::ugarchfit(spec=spec,data=data,solver="hybrid", ...)@fit
ets <- function(data) forecast::ets(ts(data))
linreg <- function(data) {
  #browser()
  data <- as.data.frame(data)
  colnames(data) <- "x"
  data$t <- 1:nrow(data)
  
  #Adjusting a linear regression to the whole window
  lm(x~t, data)
}

#Garch specs
garch11 <- rugarch::ugarchspec(variance.model = list(model = "sGARCH", garchOrder = c(1, 1)), 
                               mean.model = list(armaOrder = c(1, 1), include.mean = TRUE), 
                               distribution.model = "norm")

####################################
##### Garch Volatility Outlier #####
####################################

##### 1. cli #####
#Detect
garch_volatility_cli <- evtdet.garch_volatility_outlier(test_cli, spec = garch11, alpha = 1.5,
                                                        na.action = na.omit)

#Evaluate
evaluate(garch_volatility_cli, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     14     18
# FALSE    51     166 

round(evaluate(garch_volatility_cli, reference, metric = "F1"), 2)          # 0.29
round(evaluate(garch_volatility_cli, reference, metric = "accuracy"), 2)    # 0.72
round(evaluate(garch_volatility_cli, reference, metric = "sensitivity"), 2) # 0.22
round(evaluate(garch_volatility_cli, reference, metric = "specificity"), 2) # 0.90
round(evaluate(garch_volatility_cli, reference, metric = "precision"), 2)   # 0.44
round(evaluate(garch_volatility_cli, reference, metric = "recall"), 2)      # 0.22

#Plot
print(evtplot(test_cli, garch_volatility_cli, reference))

##### 2. ibcbr #####
#Detect
garch_volatility_ibcbr <- evtdet.garch_volatility_outlier(test_ibcbr, spec = garch11, alpha = 1.5, 
                                                          na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1

#Evaluate
evaluate(garch_volatility_ibcbr, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(garch_volatility_ibcbr, reference, metric = "F1"), 2)          # 
round(evaluate(garch_volatility_ibcbr, reference, metric = "accuracy"), 2)    # 
round(evaluate(garch_volatility_ibcbr, reference, metric = "sensitivity"), 2) # 
round(evaluate(garch_volatility_ibcbr, reference, metric = "specificity"), 2) # 
round(evaluate(garch_volatility_ibcbr, reference, metric = "precision"), 2)   # 
round(evaluate(garch_volatility_ibcbr, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_ibcbr, garch_volatility_ibcbr, reference))

##### 3. pi_sudeste #####
#Detect
garch_volatility_pi_sudeste <- evtdet.garch_volatility_outlier(test_pi_sudeste, spec = garch11,
                                                               alpha = 1.5, na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1

#Evaluate
evaluate(garch_volatility_pi_sudeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(garch_volatility_pi_sudeste, reference, metric = "F1"), 2)          # 
round(evaluate(garch_volatility_pi_sudeste, reference, metric = "accuracy"), 2)    # 
round(evaluate(garch_volatility_pi_sudeste, reference, metric = "sensitivity"), 2) # 
round(evaluate(garch_volatility_pi_sudeste, reference, metric = "specificity"), 2) # 
round(evaluate(garch_volatility_pi_sudeste, reference, metric = "precision"), 2)   # 
round(evaluate(garch_volatility_pi_sudeste, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_pi_sudeste, garch_volatility_pi_sudeste, reference))

##### 4. pi_norte #####
#Detect
garch_volatility_pi_norte <- evtdet.garch_volatility_outlier(test_pi_norte, spec = garch11, alpha = 1.5,
                                                             na.action = na.omit)

#  Error in data.frame(..., check.names = FALSE) : 
#    arguments imply differing number of rows: 0, 1 

#Evaluate
evaluate(garch_volatility_pi_norte, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     11     12  
# FALSE    54     172    

round(evaluate(garch_volatility_pi_norte, reference, metric = "F1"), 2)          # 0.25
round(evaluate(garch_volatility_pi_norte, reference, metric = "accuracy"), 2)    # 0.73
round(evaluate(garch_volatility_pi_norte, reference, metric = "sensitivity"), 2) # 0.17
round(evaluate(garch_volatility_pi_norte, reference, metric = "specificity"), 2) # 0.93
round(evaluate(garch_volatility_pi_norte, reference, metric = "precision"), 2)   # 0.48
round(evaluate(garch_volatility_pi_norte, reference, metric = "recall"), 2)      # 0.17

#Plot
print(evtplot(test_pi_norte, garch_volatility_pi_norte, reference))

##### 5. pi_sul #####
#Detect
garch_volatility_pi_sul <- evtdet.garch_volatility_outlier(test_pi_sul, spec = garch11, alpha = 1.5,
                                                           na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1

#Evaluate
evaluate(garch_volatility_pi_sul, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(garch_volatility_pi_sul, reference, metric = "F1"), 2)          # 
round(evaluate(garch_volatility_pi_sul, reference, metric = "accuracy"), 2)    # 
round(evaluate(garch_volatility_pi_sul, reference, metric = "sensitivity"), 2) # 
round(evaluate(garch_volatility_pi_sul, reference, metric = "specificity"), 2) # 
round(evaluate(garch_volatility_pi_sul, reference, metric = "precision"), 2)   # 
round(evaluate(garch_volatility_pi_sul, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_pi_sul, garch_volatility_pi_sul, reference))

##### 6. pi_centro_oeste #####
#Detect
garch_volatility_pi_centro_oeste <- evtdet.garch_volatility_outlier(test_pi_centro_oeste, spec = garch11, 
                                                                    alpha = 1.5, na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1 

#Evaluate
evaluate(garch_volatility_pi_centro_oeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(garch_volatility_pi_centro_oeste, reference, metric = "F1"), 2)          # 
round(evaluate(garch_volatility_pi_centro_oeste, reference, metric = "accuracy"), 2)    # 
round(evaluate(garch_volatility_pi_centro_oeste, reference, metric = "sensitivity"), 2) # 
round(evaluate(garch_volatility_pi_centro_oeste, reference, metric = "specificity"), 2) # 
round(evaluate(garch_volatility_pi_centro_oeste, reference, metric = "precision"), 2)   # 
round(evaluate(garch_volatility_pi_centro_oeste, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_pi_centro_oeste, garch_volatility_pi_centro_oeste, reference))

##### 7. pi_nordeste #####
#Detect
garch_volatility_pi_nordeste <- evtdet.garch_volatility_outlier(test_pi_nordeste, spec = garch11, alpha = 1.5,
                                                                na.action = na.omit)

#Error in data.frame(..., check.names = FALSE) : 
#  arguments imply differing number of rows: 0, 1 

#Evaluate
evaluate(garch_volatility_pi_nordeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     
# FALSE    

round(evaluate(garch_volatility_pi_nordeste, reference, metric = "F1"), 2)          # 
round(evaluate(garch_volatility_pi_nordeste, reference, metric = "accuracy"), 2)    # 
round(evaluate(garch_volatility_pi_nordeste, reference, metric = "sensitivity"), 2) # 
round(evaluate(garch_volatility_pi_nordeste, reference, metric = "specificity"), 2) # 
round(evaluate(garch_volatility_pi_nordeste, reference, metric = "precision"), 2)   # 
round(evaluate(garch_volatility_pi_nordeste, reference, metric = "recall"), 2)      # 

#Plot
print(evtplot(test_pi_nordeste, garch_volatility_pi_nordeste, reference))

#######################################
##### Seminal Change Point (1999) #####
#######################################

##### 1. cli #####
#Detect
changepoint_cli <- evtdet.seminalChangePoint2(test_cli, w = 30, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changepoint_cli, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     12     19  
# FALSE    53     165 

round(evaluate(changepoint_cli, reference, metric = "F1"), 2)          # 0.25
round(evaluate(changepoint_cli, reference, metric = "accuracy"), 2)    # 0.71
round(evaluate(changepoint_cli, reference, metric = "sensitivity"), 2) # 0.18
round(evaluate(changepoint_cli, reference, metric = "specificity"), 2) # 0.90
round(evaluate(changepoint_cli, reference, metric = "precision"), 2)   # 0.39
round(evaluate(changepoint_cli, reference, metric = "recall"), 2)      # 0.18

#Plot
print(evtplot(test_cli, changepoint_cli, reference))

##### 2. ibcbr #####
#Detect
changepoint_ibcbr <- evtdet.seminalChangePoint2(test_ibcbr, w = 30, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changepoint_ibcbr, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     19     26
# FALSE    46     158

round(evaluate(changepoint_ibcbr, reference, metric = "F1"), 2)          # 0.35
round(evaluate(changepoint_ibcbr, reference, metric = "accuracy"), 2)    # 0.71
round(evaluate(changepoint_ibcbr, reference, metric = "sensitivity"), 2) # 0.29
round(evaluate(changepoint_ibcbr, reference, metric = "specificity"), 2) # 0.86
round(evaluate(changepoint_ibcbr, reference, metric = "precision"), 2)   # 0.42
round(evaluate(changepoint_ibcbr, reference, metric = "recall"), 2)      # 0.29

#Plot
print(evtplot(test_ibcbr, changepoint_ibcbr, reference))

##### 3. pi_sudeste #####
#Detect
changepoint_pi_sudeste <- evtdet.seminalChangePoint2(test_pi_sudeste, w = 30, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changepoint_pi_sudeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     16     28 
# FALSE    49     156  

round(evaluate(changepoint_pi_sudeste, reference, metric = "F1"), 2)          # 0.29
round(evaluate(changepoint_pi_sudeste, reference, metric = "accuracy"), 2)    # 0.69
round(evaluate(changepoint_pi_sudeste, reference, metric = "sensitivity"), 2) # 0.25
round(evaluate(changepoint_pi_sudeste, reference, metric = "specificity"), 2) # 0.85
round(evaluate(changepoint_pi_sudeste, reference, metric = "precision"), 2)   # 0.36
round(evaluate(changepoint_pi_sudeste, reference, metric = "recall"), 2)      # 0.25

#Plot
print(evtplot(test_pi_sudeste, changepoint_pi_sudeste, reference))

##### 4. pi_norte #####
#Detect
changepoint_pi_norte <- evtdet.seminalChangePoint2(test_pi_norte, w = 30, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changepoint_pi_norte, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     13     36     
# FALSE    52     148 

round(evaluate(changepoint_pi_norte, reference, metric = "F1"), 2)          # 0.23
round(evaluate(changepoint_pi_norte, reference, metric = "accuracy"), 2)    # 0.65
round(evaluate(changepoint_pi_norte, reference, metric = "sensitivity"), 2) # 0.20
round(evaluate(changepoint_pi_norte, reference, metric = "specificity"), 2) # 0.80
round(evaluate(changepoint_pi_norte, reference, metric = "precision"), 2)   # 0.27
round(evaluate(changepoint_pi_norte, reference, metric = "recall"), 2)      # 0.20

#Plot
print(evtplot(test_pi_norte, changepoint_pi_norte, reference))

##### 5. pi_sul #####
#Detect
changepoint_pi_sul <- evtdet.seminalChangePoint2(test_pi_sul, w = 30, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changepoint_pi_sul, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     21     33 
# FALSE    44     151 

round(evaluate(changepoint_pi_sul, reference, metric = "F1"), 2)          # 0.35
round(evaluate(changepoint_pi_sul, reference, metric = "accuracy"), 2)    # 0.69
round(evaluate(changepoint_pi_sul, reference, metric = "sensitivity"), 2) # 0.32
round(evaluate(changepoint_pi_sul, reference, metric = "specificity"), 2) # 0.82
round(evaluate(changepoint_pi_sul, reference, metric = "precision"), 2)   # 0.39
round(evaluate(changepoint_pi_sul, reference, metric = "recall"), 2)      # 0.32

#Plot
print(evtplot(test_pi_sul, changepoint_pi_sul, reference))

##### 6. pi_centro_oeste #####
#Detect
changepoint_pi_centro_oeste <- evtdet.seminalChangePoint2(test_pi_centro_oeste, w = 30, mdl = linreg, 
                                                          na.action = na.omit)

#Evaluate
evaluate(changepoint_pi_centro_oeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     12     31
# FALSE    53     153  

round(evaluate(changepoint_pi_centro_oeste, reference, metric = "F1"), 2)          # 0.22
round(evaluate(changepoint_pi_centro_oeste, reference, metric = "accuracy"), 2)    # 0.66
round(evaluate(changepoint_pi_centro_oeste, reference, metric = "sensitivity"), 2) # 0.18
round(evaluate(changepoint_pi_centro_oeste, reference, metric = "specificity"), 2) # 0.83
round(evaluate(changepoint_pi_centro_oeste, reference, metric = "precision"), 2)   # 0.28
round(evaluate(changepoint_pi_centro_oeste, reference, metric = "recall"), 2)      # 0.18

#Plot
print(evtplot(test_pi_centro_oeste, changepoint_pi_centro_oeste, reference))

##### 7. pi_nordeste #####
#Detect
changepoint_pi_nordeste <- evtdet.seminalChangePoint2(test_pi_nordeste, w = 30, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changepoint_pi_nordeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     15     32 
# FALSE    50     152    

round(evaluate(changepoint_pi_nordeste, reference, metric = "F1"), 2)          # 0.27
round(evaluate(changepoint_pi_nordeste, reference, metric = "accuracy"), 2)    # 0.67
round(evaluate(changepoint_pi_nordeste, reference, metric = "sensitivity"), 2) # 0.23
round(evaluate(changepoint_pi_nordeste, reference, metric = "specificity"), 2) # 0.83
round(evaluate(changepoint_pi_nordeste, reference, metric = "precision"), 2)   # 0.32
round(evaluate(changepoint_pi_nordeste, reference, metric = "recall"), 2)      # 0.23

#Plot
print(evtplot(test_pi_nordeste, changepoint_pi_nordeste, reference))

###############################
##### ChangeFinder (2005) #####
###############################

##### 1. cli #####
#Detect
changefinder_cli <- evtdet.changeFinder(test_cli, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_cli, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     14     4 
# FALSE    51     180

round(evaluate(changefinder_cli, reference, metric = "F1"), 2)          # 0.34
round(evaluate(changefinder_cli, reference, metric = "accuracy"), 2)    # 0.78
round(evaluate(changefinder_cli, reference, metric = "sensitivity"), 2) # 0.22
round(evaluate(changefinder_cli, reference, metric = "specificity"), 2) # 0.98
round(evaluate(changefinder_cli, reference, metric = "precision"), 2)   # 0.78
round(evaluate(changefinder_cli, reference, metric = "recall"), 2)      # 0.22

#Plot
print(evtplot(test_cli, changefinder_cli, reference))

##### 2. ibcbr #####
#Detect
changefinder_ibcbr <- evtdet.changeFinder(test_ibcbr, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_ibcbr, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     2      1 
# FALSE    63     183  

round(evaluate(changefinder_ibcbr, reference, metric = "F1"), 2)          # 0.06
round(evaluate(changefinder_ibcbr, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(changefinder_ibcbr, reference, metric = "sensitivity"), 2) # 0.03
round(evaluate(changefinder_ibcbr, reference, metric = "specificity"), 2) # 0.99
round(evaluate(changefinder_ibcbr, reference, metric = "precision"), 2)   # 0.67
round(evaluate(changefinder_ibcbr, reference, metric = "recall"), 2)      # 0.03

#Plot
print(evtplot(test_ibcbr, changefinder_ibcbr, reference))

##### 3. pi_sudeste #####
#Detect
changefinder_pi_sudeste <- evtdet.changeFinder(test_pi_sudeste, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_pi_sudeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     2      1    
# FALSE    63     183  

round(evaluate(changefinder_pi_sudeste, reference, metric = "F1"), 2)          # 0.06
round(evaluate(changefinder_pi_sudeste, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(changefinder_pi_sudeste, reference, metric = "sensitivity"), 2) # 0.03
round(evaluate(changefinder_pi_sudeste, reference, metric = "specificity"), 2) # 0.99
round(evaluate(changefinder_pi_sudeste, reference, metric = "precision"), 2)   # 0.67
round(evaluate(changefinder_pi_sudeste, reference, metric = "recall"), 2)      # 0.03

#Plot
print(evtplot(test_pi_sudeste, changefinder_pi_sudeste, reference))

##### 4. pi_norte #####
#Detect
changefinder_pi_norte <- evtdet.changeFinder(test_pi_norte, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_pi_norte, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     3      2     
# FALSE    62     182 

round(evaluate(changefinder_pi_norte, reference, metric = "F1"), 2)          # 0.09
round(evaluate(changefinder_pi_norte, reference, metric = "accuracy"), 2)    # 0.74
round(evaluate(changefinder_pi_norte, reference, metric = "sensitivity"), 2) # 0.05
round(evaluate(changefinder_pi_norte, reference, metric = "specificity"), 2) # 0.99
round(evaluate(changefinder_pi_norte, reference, metric = "precision"), 2)   # 0.60
round(evaluate(changefinder_pi_norte, reference, metric = "recall"), 2)      # 0.05

#Plot
print(evtplot(test_pi_norte, changefinder_pi_norte, reference))

##### 5. pi_sul #####
#Detect
changefinder_pi_sul <- evtdet.changeFinder(test_pi_sul, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_pi_sul, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     3      1 
# FALSE    62     183

round(evaluate(changefinder_pi_sul, reference, metric = "F1"), 2)          # 0.09
round(evaluate(changefinder_pi_sul, reference, metric = "accuracy"), 2)    # 0.75
round(evaluate(changefinder_pi_sul, reference, metric = "sensitivity"), 2) # 0.05
round(evaluate(changefinder_pi_sul, reference, metric = "specificity"), 2) # 0.99
round(evaluate(changefinder_pi_sul, reference, metric = "precision"), 2)   # 0.75
round(evaluate(changefinder_pi_sul, reference, metric = "recall"), 2)      # 0.05

#Plot
print(evtplot(test_pi_sul, changefinder_pi_sul, reference))

##### 6. pi_centro_oeste #####
#Detect
changefinder_pi_centro_oeste <- evtdet.changeFinder(test_pi_centro_oeste, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_pi_centro_oeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     5      0  
# FALSE    60     184

round(evaluate(changefinder_pi_centro_oeste, reference, metric = "F1"), 2)          # 0.14
round(evaluate(changefinder_pi_centro_oeste, reference, metric = "accuracy"), 2)    # 0.76
round(evaluate(changefinder_pi_centro_oeste, reference, metric = "sensitivity"), 2) # 0.08
round(evaluate(changefinder_pi_centro_oeste, reference, metric = "specificity"), 2) # 1.00
round(evaluate(changefinder_pi_centro_oeste, reference, metric = "precision"), 2)   # 1.00
round(evaluate(changefinder_pi_centro_oeste, reference, metric = "recall"), 2)      # 0.08

#Plot
print(evtplot(test_pi_centro_oeste, changefinder_pi_centro_oeste, reference))

##### 7. pi_nordeste #####
#Detect
changefinder_pi_nordeste <- evtdet.changeFinder(test_pi_nordeste, mdl = linreg, na.action = na.omit)

#Evaluate
evaluate(changefinder_pi_nordeste, reference, metric = "confusion_matrix")
# Detected TRUE   FALSE
# TRUE     6      2   
# FALSE    59     182  

round(evaluate(changefinder_pi_nordeste, reference, metric = "F1"), 2)          # 0.16
round(evaluate(changefinder_pi_nordeste, reference, metric = "accuracy"), 2)    # 0.76
round(evaluate(changefinder_pi_nordeste, reference, metric = "sensitivity"), 2) # 0.09
round(evaluate(changefinder_pi_nordeste, reference, metric = "specificity"), 2) # 0.99
round(evaluate(changefinder_pi_nordeste, reference, metric = "precision"), 2)   # 0.75
round(evaluate(changefinder_pi_nordeste, reference, metric = "recall"), 2)      # 0.09

#Plot
print(evtplot(test_pi_nordeste, changefinder_pi_nordeste, reference))